seo:
  title: Battling toolchain technical debt
  description: >-
    DevOps teams can hinder the software development lifecycles and application
    performance if they let their toolchains become unruly. Read how GitLab can
    help reduce that technical debt.
  ogTitle: Battling toolchain technical debt
  ogDescription: >-
    DevOps teams can hinder the software development lifecycles and application
    performance if they let their toolchains become unruly. Read how GitLab can
    help reduce that technical debt.
  noIndex: false
  ogImage: images/blog/hero-images/gl15.jpg
  ogUrl: https://about.gitlab.com/blog/battling-toolchain-technical-debt
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/battling-toolchain-technical-debt
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "Battling toolchain technical debt",
            "author": [{"@type":"Person","name":"Sandra Gittlen"}],
            "datePublished": "2022-06-21",
          }

content:
  title: Battling toolchain technical debt
  description: >-
    DevOps teams can hinder the software development lifecycles and application
    performance if they let their toolchains become unruly. Read how GitLab can
    help reduce that technical debt.
  authors:
    - Sandra Gittlen
  heroImage: images/blog/hero-images/gl15.jpg
  date: '2022-06-21'
  body: >

    Developers love their tools. Operations teams love their tools. And security
    teams love their tools. As Dev, Sec, and Ops consolidate onto a single
    DevOps platform, toolchain technical debt becomes exponentially more costly
    and complex. 


    “Tools should be in the background enabling excellent development,
    operations, and security practices. However, DevOps teams are often led by
    their tools rather than the other way around and that can hinder all aspects
    of the software development lifecycle (SDLC),” says [Cindy
    Blake](https://gitlab.com/cblake), CISSP, director of product and solutions
    marketing at GitLab.


    An April 2022 Gartner® report titled “Beware the DevOps Toolchain Debt
    Collector” notes that “many organizations find themselves with outdated,
    poorly governed, and unmanageable toolchains as they scale DevOps
    initiatives.” 


    One of the key findings, according to Gartner, is that “most organizations
    create homegrown toolchains, often leveraging the tools beyond their
    functional design. This not only leads to a fragmented toolchain, but also
    creates complications when tooling needs to be scaled, replaced, or
    updated.” 


    Toolchain technical debt introduces complexity as companies shift critical
    tasks such as reliability, governance, and compliance left in the SDLC. 


    > Discover how GitLab 15 can help your team deliver secure software, while
    maintaining compliance and automating manual processes.

    Save the date for our GitLab 15 [launch
    event](https://page.gitlab.com/fifteen) on June 23rd!


    ## No time for technical debt 


    Few DevOps teams give toolchain upkeep the time and attention it requires.
    According to [GitLab’s 2021 DevSecOps 

    survey](/images/developer-survey/gitlab-devsecops-2021-survey-results.pdf),
    nearly two-thirds of survey respondents, 61%, said they spend 20% or less of
    their time on toolchain integration and maintenance each month. 


    “Developers face challenges and time constraints while maintaining these
    complex, stand-alone tool siloes, building fragility and technical debt that
    the [infrastructure and operations] leader has to deal with,” Gartner
    states. The research firm adds, “These outdated toolchains further increase
    overhead costs, magnify technical risks, add operational toil, and limit
    business agility.” 


    Blake agrees: “Complex toolchains inhibit the ability to govern the software
    development and deployment process. Policies must be managed across tools
    and visibility into code changes and changes to its surrounding
    infrastructure become difficult to see and track. Time is wasted on managing
    the toolchain instead of value-added work.”


    ## Getting purpose-driven 

    The remedy to toolchain sprawl and subsequent debt is to change strategy.
    Instead of putting energy into figuring out how to maintain one-off tools,
    DevOps teams should focus on how to enable processes and policies that
    support simplicity, control, and visibility across the SDLC. 


    “These are the characteristics needed to meet reliability, governance, and
    compliance demands. A united platform like GitLab helps you do that,” Blake
    says. 


    Gartner states: “Successful infrastructure and operations leaders reduce
    technical debt and sustainably scale DevOps toolchain initiatives across the
    organization by using a prioritized, iterative strategy that minimizes
    friction in making changes to toolchains and more quickly delivers customer
    value.” 


    Adopting a purpose-built platform instead of a complex and ad-hoc toolchain
    also eases an organization’s ability to automate the SDLC. “Automation
    abstracts complexity away from the developer and provides guard rails so
    DevOps teams gain greater efficiency, accuracy, and consistency,” Blake
    says. In addition, automation reduces the audit footprint in terms of what
    needs oversight and inspection. 


    Platforms also support automation throughout operations, including building
    and 

    testing infrastructure as code, so that “you can eliminate the variables
    when you’re trying to debug an application,” she says. This speeds
    troubleshooting response times and reduces application downtime. 


    For instance, GitLab, the One DevOps Platform, features [dependency 

    lists](https://docs.gitlab.com/ee/user/application_security/dependency_list/),
    also known as software bill of materials (SBOM), that show which
    dependencies were used and help to identify where problems exist. “GitLab
    also helps you avoid problems altogether by consistently scanning
    dependencies according to policies and compliance standards that the
    platform provides,” Blake says. DevOps teams can easily see what changes
    were made when and by whom. “That visibility is critical when trying to
    resolve issues and prevent them from happening again,” she says.


    ## Reclaim your DevOps team’s time 

    By adopting a single DevOps platform, organizations can reclaim developer,
    security, and operations time that has been spent stitching tools together
    or optimizing for one developer’s tool, and then backtracking through
    toolchains when an application breaks because those tools can’t co-exist.


    “DevOps teams have a lot on their plates and trying to manage unruly
    toolchains is simply a waste of time. You should be creating
    state-of-the-art software, not manually integrating and maintaining legacy
    tools,” Blake says. 


    She emphasizes that GitLab is not “rip and replace”; it’s a platform where
    everything needed for DevOps comes together in one place. IT leadership
    benefits from this united approach as well. [Value stream 

    analytics](/stages-devops-lifecycle/value-stream-analytics/) provide insight
    into your end-to-end software throughput, helping optimize IT resources most
    efficiently and enabling a flexible, responsive business outcome. “We meet
    DevOps teams where they are and put the user – whether they be a developer,
    operations, or security professional – in the center of the platform,” she
    says. 


    [Try GitLab Ultimate for free](/free-trial/ 

    ) for 30 days.


    _GARTNER is a registered trademark and service mark of Gartner, Inc. and/or
    its affiliates in the U.S. and internationally and is used herein with
    permission. All rights reserved._
  category: DevSecOps
  tags:
    - DevOps
    - performance
    - workflow
config:
  slug: battling-toolchain-technical-debt
  featured: false
  template: BlogPost
